from PIL import Image
import random
import cv2
import numpy as np
from matplotlib import pyplot as plt
from torch.utils.data import DataLoader, Dataset
from torchvision import datasets, transforms
import torch

def data_read_avg(path): 
    #print(path.shape)
    #print(path[0])
    img = Image.open(path[0])
    img.convert('RGB') 
    img = img.resize((512,512),Image.ANTIALIAS)
    img_label = Image.open(path[1]).resize((512,512),Image.ANTIALIAS)
    if "Magrabia" in path[0]:
       #print("aaaaaaa")
       img_label = np.array(img_label)
       ret,label = cv2.threshold(img_label,127,1, cv2.THRESH_BINARY)
       apply_transform = transforms.Compose(
          [transforms.ToTensor(),
           transforms.Normalize((0.56872565, 0.38049117, 0.15330379), (0.25137043, 0.17862958, 0.112669505))])
       img = apply_transform(img)
    if "MESSIDOR" in path[0]:
       #print("aaaaaaa")
       img_label = np.array(img_label)
       ret,label = cv2.threshold(img_label,127,1, cv2.THRESH_BINARY)
       apply_transform = transforms.Compose(
          [transforms.ToTensor(),
           transforms.Normalize((0.29205734, 0.14271256, 0.051214207), (0.3298716, 0.16581915, 0.066206366))])
       img = apply_transform(img)
    if "Drishti-GS1" in path[0]:
       #print("aaaaaaa")
       img_label = np.array(img_label)
       ret,label = cv2.threshold(img_label,127,1, cv2.THRESH_BINARY)
       apply_transform = transforms.Compose(
          [transforms.ToTensor(),
           transforms.Normalize((0.3319488, 0.15794754, 0.04981234), (0.20317358, 0.10700586, 0.039032888))])
       img = apply_transform(img)
       
    if "BinRushed" in path[0]:
       #print("bbbbbbb")
       label = np.array(img_label)
       apply_transform = transforms.Compose(
          [transforms.ToTensor(),
           transforms.Normalize((0.21337573, 0.12928146, 0.08100902), (0.2643701, 0.16699813, 0.10816506))])
       img = apply_transform(img)
       
    if "IDRID" in path[0]:
       #print("bbbbbbb")
       label = np.array(img_label)
       apply_transform = transforms.Compose(
          [transforms.ToTensor(),
           transforms.Normalize((0.45807034, 0.22371899, 0.065630354), (0.32455647, 0.17066097, 0.08738527))])
       img = apply_transform(img)
       
    if "REFUGE" in path[0]:
       #print("ccccccc")
       img_label.convert('L') 
       img_label = np.array(img_label)
       ret,label = cv2.threshold(img_label,10,1, 1)
       apply_transform = transforms.Compose(
          [transforms.ToTensor(),
           transforms.Normalize((0.35669565, 0.22980179, 0.16539596), (0.2590761, 0.17932242, 0.14770536))])
       img = apply_transform(img)
    
    if "RIM-ONE" in path[0]:
       #print("dddddd")
       label = np.array(img_label).astype(int)
       apply_transform = transforms.Compose(
          [transforms.ToTensor(),
           transforms.Normalize((0.5694748, 0.2321112, 0.12419897), (0.16033256, 0.121063605, 0.08985739))])
       img = apply_transform(img)
  
    return img, np.array(label).astype(int)



def data_read(path): 
    #print(path.shape)
    #print(path[0])
    img = Image.open(path[0])
    img.convert('RGB') 
    img = img.resize((256,256),Image.ANTIALIAS)
    img_label = Image.open(path[1]).resize((256,256),Image.ANTIALIAS)
    if "Magrabia" in path[0]:
       #print("aaaaaaa")
       img_label = np.array(img_label)
       ret,label = cv2.threshold(img_label,127,1, cv2.THRESH_BINARY)
    if "MESSIDOR" in path[0]:
       #print("aaaaaaa")
       img_label = np.array(img_label)
       ret,label = cv2.threshold(img_label,127,1, cv2.THRESH_BINARY)
    if "Drishti-GS1" in path[0]:
       #print("aaaaaaa")
       img_label = np.array(img_label)
       ret,label = cv2.threshold(img_label,127,1, cv2.THRESH_BINARY)
       
    if "BinRushed" in path[0]:
       #print("bbbbbbb")
       label = np.array(img_label)
       
    if "IDRID" in path[0]:
       #print("bbbbbbb")
       label = np.array(img_label)
       
    if "REFUGE" in path[0]:
       #print("ccccccc")
       img_label.convert('L') 
       img_label = np.array(img_label)
       h,w = img_label.shape
       for i in range(h):
           for j in range(w):
               if img_label[i][j] == 255:
                  img_label[i][j] = 0
               else:
                  img_label[i][j] = 1
       label = img_label
       #ret,label = cv2.threshold(img_label,10,1, 1)
    
    if "RIM-ONE" in path[0]:
       #print("dddddd")
       label = np.array(img_label).astype(int)
    apply_transform = transforms.Compose(
      [transforms.ToTensor()])
       ## [0.35381392, 0.19792648, 0.109140955], normStd = [0.2853565, 0.1724628, 0.12016233])
    img = apply_transform(img)
    #print(img[0][1])
  
    return img, np.array(label).astype(int)



class Datasetsplit(Dataset):
    """An abstract Dataset class wrapped around Pytorch Dataset class.
    """

    def __init__(self, path):
        self.dataset = path[:]

    def __len__(self):
        return len(self.dataset)

    def __getitem__(self, item):
        image, label = data_read(self.dataset[item])
        #print(image.dtype)
        #print(torch.tensor(image))
        return image, label


"""
normMean = [0.4967411, 0.31040248, 0.2248057]
normStd = [0.3161397, 0.22419964, 0.18269733]
transforms.Normalize(normMean = [0.4967411, 0.31040248, 0.2248057], normStd = [0.3161397, 0.22419964, 0.18269733])

"""



def data_read_EndoPolyp(path): 
    #print(path.shape)
    #print(path[0])
    img = Image.open(path[0])
    img.convert('RGB') 
    img = img.resize((256,256),Image.ANTIALIAS)
    img_label = Image.open(path[1]).resize((256,256),Image.ANTIALIAS)
    if "CVC-ColonDB" in path[0]:
        img_label = np.array(img_label)
        ret,label = cv2.threshold(img_label,127,1, cv2.THRESH_BINARY)
    if "ETIS-LaribPolypDB" in path[0]:
        img_label = np.array(img_label)
        ret,label = cv2.threshold(img_label,127,1, cv2.THRESH_BINARY)
    if "CVC-ClinicDB" in path[0]:
        img_label = img_label.convert('L')
        img_label = np.array(img_label)
        ret,label = cv2.threshold(img_label,127,1, cv2.THRESH_BINARY)
    if "Kvasir-SEG" in path[0]:
        img_label = img_label.convert('L')
        img_label = np.array(img_label)
        ret,label = cv2.threshold(img_label,127,1, cv2.THRESH_BINARY)
    apply_transform = transforms.Compose(
      [transforms.ToTensor()])
    #transforms.Normalize((0.4967411, 0.31040248, 0.2248057), (0.3161397, 0.22419964, 0.18269733))
       # ## [0.35381392, 0.19792648, 0.109140955], normStd = [0.2853565, 0.1724628, 0.12016233])
    img = apply_transform(img)
    # #print(img[0][1])
  
    return img, np.array(label).astype(int)




class Datasetsplit_EndoPolyp(Dataset):
    """An abstract Dataset class wrapped around Pytorch Dataset class.
    """

    def __init__(self, path):
        self.dataset = path[:]

    def __len__(self):
        return len(self.dataset)

    def __getitem__(self, item):
        image, label = data_read_EndoPolyp(self.dataset[item])
        #print(image.dtype)
        #print(torch.tensor(image))
        return image, label







def data_read_PMR(path): 
    #print(path.shape)
    # print(path[0])
    img = np.load(path[0])
    img = img.reshape(1,384,384)
    #img = img.resize((256,256),Image.ANTIALIAS)
    label = np.load(path[1])
    # #print(img[0][1])
  
    return img, np.array(label).astype(int)


class Datasetsplit_PMR(Dataset):
    """An abstract Dataset class wrapped around Pytorch Dataset class.
    """

    def __init__(self, path):
        self.dataset = path[:]

    def __len__(self):
        return len(self.dataset)

    def __getitem__(self, item):
        image, label = data_read_PMR(self.dataset[item])
        #print(image.dtype)
        #print(torch.tensor(image))
        return image, label


















# path = "/home/xly/pFred_medical_segmentation/data_process/data_list/BIDMC_train.txt"##0.8
# path1 = "/home/xly/pFred_medical_segmentation/data_process/data_list/ETIS-LaribPolypDB.txt"
# path2 = "/home/xly/pFred_medical_segmentation/data_process/data_list/CVC-ClinicDB.txt"
# path3 = "/home/xly/pFred_medical_segmentation/data_process/data_list/Kvasir-SEG.txt"
# # path4 = "/home/xly/pFred_medical_segmentation/data_process/data_list/MESSIDOR.txt"
# # path5 = "/home/xly/pFred_medical_segmentation/data_process/data_list/REFUGE_Train.txt"
# # path6 = "/home/xly/pFred_medical_segmentation/data_process/data_list/Drishti_GS1_Train.txt"


# train_dataset1 = np.loadtxt(path, dtype=str, delimiter='  ')##ok
# train_dataset2 = np.loadtxt(path1, dtype=str, delimiter='  ')##ok
# train_dataset3 = np.loadtxt(path2, dtype=str, delimiter='  ')##ok
# train_dataset4 = np.loadtxt(path3, dtype=str, delimiter='  ')
# # train_dataset5 = np.loadtxt(path4, dtype=str, delimiter='  ')##ok
# # train_dataset6 = np.loadtxt(path5, dtype=str, delimiter='  ')##ok
# # train_dataset7 = np.loadtxt(path6, dtype=str, delimiter='  ')##ok


# img,img_label = data_read_PMR(train_dataset1[0])
# plt.imshow(img)#,cmap = 'gray'
# plt.show()
# plt.imshow(img_label)#,cmap = 'gray'
# plt.show()

# img,img_label = data_read_EndoPolyp(train_dataset2[0])
# plt.imshow(img)#,cmap = 'gray'
# plt.show()
# plt.imshow(img_label)#,cmap = 'gray'
# plt.show()

# img,img_label = data_read_EndoPolyp(train_dataset3[0])
# plt.imshow(img)#,cmap = 'gray'
# plt.show()
# plt.imshow(img_label)#,cmap = 'gray'
# plt.show()

# img,img_label = data_read_EndoPolyp(train_dataset4[0])
# plt.imshow(img)#,cmap = 'gray'
# plt.show()
# plt.imshow(img_label)#,cmap = 'gray'
# plt.show()

# # img,img_label = data_read(train_dataset5[0])
# # plt.imshow(img)#,cmap = 'gray'
# # plt.show()
# # plt.imshow(img_label)#,cmap = 'gray'
# # plt.show()

# for i in range(len(train_dataset6)):
    # img,img_label = data_read(train_dataset6[i])
    # plt.imshow(img)#,cmap = 'gray'
    # plt.show()
    # plt.imshow(img_label)#,cmap = 'gray'
    # plt.show()

# # img,img_label = data_read(train_dataset7[0])
# # plt.imshow(img)#,cmap = 'gray'
# # plt.show()
# # plt.imshow(img_label)#,cmap = 'gray'
# # plt.show()








# # print(train_dataset1[0][0])
# # img = Image.open(train_dataset1[0][0])
# # img.convert('RGB') 
# # img = np.array(img)
# # #print(img.shape)
# # img_label = Image.open(train_dataset1[0][1])
# # img_label.convert('L') 
# # print(img.shape)
# # #img.convert('RGB') 
# # plt.imshow(img)#,cmap = 'gray'
# # plt.show()
# # if "RIM-ONE" in train_dataset1[0][0]:
   # # print()
   # # img_label = Image.open(train_dataset1[0][1])
   # # img_label.convert('L') 
   # # img_label = np.array(img_label)
   # # print(img_label.shape)
   # # #ret,img_label = cv2.threshold(img_label,127,1, 1)
# # plt.imshow(img_label)#,cmap = 'gray'
# # plt.show()
# # plt.imshow(img_label)#,cmap = 'gray'
# # plt.show()