#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Python version: 3.6

import copy
import torch
from torchvision import datasets, transforms
import numpy as np





def get_dataset(idx,task):
    if task == "RIF":
        SEED =1
        torch.manual_seed(SEED)
        torch.backends.cudnn.deterministic = False
        torch.backends.cudnn.benchmark = False
        np.random.seed(SEED)
        path = "/home/xly/pFred_medical_segmentation/data_process/data_list/BinRushed.txt"##0.8
        path1 = "/home/xly/pFred_medical_segmentation/data_process/data_list/Magrabia.txt"##0.8
        path2 = "/home/xly/pFred_medical_segmentation/data_process/data_list/IDRID_Train.txt"
        path3 = "/home/xly/pFred_medical_segmentation/data_process/data_list/RIM-ONE.txt"##0.8
        path4 = "/home/xly/pFred_medical_segmentation/data_process/data_list/MESSIDOR.txt"##0.8
        path5 = "/home/xly/pFred_medical_segmentation/data_process/data_list/REFUGE_Train.txt"
        path6 = "/home/xly/pFred_medical_segmentation/data_process/data_list/Drishti_GS1_Train.txt"


        train_dataset1 = np.loadtxt(path, dtype=str, delimiter='  ')
        train_dataset2 = np.loadtxt(path1, dtype=str, delimiter='  ')
        train_dataset3 = np.loadtxt(path2, dtype=str, delimiter='  ')
        train_dataset4 = np.loadtxt(path3, dtype=str, delimiter='  ')
        train_dataset5 = np.loadtxt(path4, dtype=str, delimiter='  ')
        train_dataset6 = np.loadtxt(path5, dtype=str, delimiter='  ')
        train_dataset7 = np.loadtxt(path6, dtype=str, delimiter='  ')

        permutation = np.random.permutation(train_dataset1.shape[0])####数据随机
        #print(permutation)
        train_dataset1 = train_dataset1[permutation]
        test_dataset1 = train_dataset1[int(0.5*len(train_dataset1)):]
        train_dataset1 = train_dataset1[:int(0.5*len(train_dataset1))]

        permutation = np.random.permutation(train_dataset2.shape[0])####数据随机
        train_dataset2 = train_dataset2[permutation]
        test_dataset2 = train_dataset2[int(0.5*len(train_dataset2)):]
        train_dataset2 = train_dataset2[:int(0.5*len(train_dataset2))]

        permutation = np.random.permutation(train_dataset4.shape[0])####数据随机
        train_dataset4 = train_dataset4[permutation]
        test_dataset4 = train_dataset4[int(0.5*len(train_dataset4)):]
        train_dataset4 = train_dataset4[:int(0.5*len(train_dataset4))]

        permutation = np.random.permutation(train_dataset5.shape[0])####数据随机
        train_dataset5 = train_dataset5[permutation]
        test_dataset5 = train_dataset5[int(0.5*len(train_dataset5)):]
        train_dataset5 = train_dataset5[:int(0.5*len(train_dataset5))]

        path2_test = "/home/xly/pFred_medical_segmentation/data_process/data_list/IDRID_Test.txt"
        path5_test = "/home/xly/pFred_medical_segmentation/data_process/data_list/REFUGE_Validation.txt"
        path6_test = "/home/xly/pFred_medical_segmentation/data_process/data_list/Drishti_GS1_Test.txt"

        test_dataset6 = np.loadtxt(path5_test, dtype=str, delimiter='  ')
        test_dataset3 = np.loadtxt(path2_test, dtype=str, delimiter='  ')
        test_dataset7 = np.loadtxt(path6_test, dtype=str, delimiter='  ')
        #Train_list = train_dataset7#np.concatenate([train_dataset1,train_dataset2,train_dataset3,train_dataset4,train_dataset5,train_dataset6,train_dataset7],0)
        #Test_list = np.concatenate([test_dataset1,test_dataset2,test_dataset3,test_dataset4,test_dataset5,test_dataset6,test_dataset7],0)
        if idx == 0:
           train_dataset = train_dataset1
           test_dataset = test_dataset1
        if idx == 1:
           train_dataset = train_dataset2
           test_dataset = test_dataset2
        if idx == 2:
           train_dataset = train_dataset3
           test_dataset = test_dataset3
        if idx == 3:
           train_dataset = train_dataset4
           test_dataset = test_dataset4
        if idx == 4:
           train_dataset = train_dataset5
           test_dataset = test_dataset5
        if idx == 5:
           train_dataset = train_dataset6
           test_dataset = test_dataset6
        if idx == 6:
           train_dataset = train_dataset7
           test_dataset = test_dataset7
        return train_dataset, test_dataset
    if task == "EndoPolyp":
        SEED =1
        torch.manual_seed(SEED)
        torch.backends.cudnn.deterministic = False
        torch.backends.cudnn.benchmark = False
        np.random.seed(SEED)
        path = "/home/xly/pFred_medical_segmentation/data_process/data_list/CVC-ColonDB.txt"
        path1 = "/home/xly/pFred_medical_segmentation/data_process/data_list/ETIS-LaribPolypDB.txt"
        path2 = "/home/xly/pFred_medical_segmentation/data_process/data_list/CVC-ClinicDB.txt"
        path3 = "/home/xly/pFred_medical_segmentation/data_process/data_list/Kvasir-SEG.txt"


        train_dataset1 = np.loadtxt(path, dtype=str, delimiter='  ')
        train_dataset2 = np.loadtxt(path1, dtype=str, delimiter='  ')
        train_dataset3 = np.loadtxt(path2, dtype=str, delimiter='  ')
        train_dataset4 = np.loadtxt(path3, dtype=str, delimiter='  ')

        permutation = np.random.permutation(train_dataset1.shape[0])####数据随机
        train_dataset1 = train_dataset1[permutation]
        test_dataset1 = train_dataset1[int(0.5*len(train_dataset1)):]
        train_dataset1 = train_dataset1[:int(0.5*len(train_dataset1))]

        permutation = np.random.permutation(train_dataset2.shape[0])####数据随机
        train_dataset2 = train_dataset2[permutation]
        test_dataset2 = train_dataset2[int(0.5*len(train_dataset2)):]
        train_dataset2 = train_dataset2[:int(0.5*len(train_dataset2))]

        permutation = np.random.permutation(train_dataset4.shape[0])####数据随机
        train_dataset4 = train_dataset4[permutation]
        test_dataset4 = train_dataset4[int(0.5*len(train_dataset4)):]
        train_dataset4 = train_dataset4[:int(0.5*len(train_dataset4))]

        permutation = np.random.permutation(train_dataset3.shape[0])####数据随机
        train_dataset3 = train_dataset3[permutation]
        test_dataset3 = train_dataset3[int(0.5*len(train_dataset3)):]
        train_dataset3 = train_dataset3[:int(0.5*len(train_dataset3))]
        #Train_list = train_dataset7#np.concatenate([train_dataset1,train_dataset2,train_dataset3,train_dataset4,train_dataset5,train_dataset6,train_dataset7],0)
        #Test_list = np.concatenate([test_dataset1,test_dataset2,test_dataset3,test_dataset4,test_dataset5,test_dataset6,test_dataset7],0)
        if idx == 0:
           train_dataset = train_dataset1
           test_dataset = test_dataset1
        if idx == 1:
           train_dataset = train_dataset2
           test_dataset = test_dataset2
        if idx == 2:
           train_dataset = train_dataset3
           test_dataset = test_dataset3
        if idx == 3:
           train_dataset = train_dataset4
           test_dataset = test_dataset4
        return train_dataset, test_dataset
    if task == "PMR":
        SEED =1
        torch.manual_seed(SEED)
        torch.backends.cudnn.deterministic = False
        torch.backends.cudnn.benchmark = False
        np.random.seed(SEED)
        path = "/home/xly/pFred_medical_segmentation/data_process/data_list/BIDMC_train.txt"##0.8
        path1 = "/home/xly/pFred_medical_segmentation/data_process/data_list/BMC_train.txt"##0.8
        path2 = "/home/xly/pFred_medical_segmentation/data_process/data_list/HK_train.txt"
        path3 = "/home/xly/pFred_medical_segmentation/data_process/data_list/I2CVB_train.txt"##0.8
        path4 = "/home/xly/pFred_medical_segmentation/data_process/data_list/RUNMC_train.txt"##0.8
        path5 = "/home/xly/pFred_medical_segmentation/data_process/data_list/UCL_train.txt"


        train_dataset1 = np.loadtxt(path, dtype=str, delimiter='  ')
        train_dataset2 = np.loadtxt(path1, dtype=str, delimiter='  ')
        train_dataset3 = np.loadtxt(path2, dtype=str, delimiter='  ')
        train_dataset4 = np.loadtxt(path3, dtype=str, delimiter='  ')
        train_dataset5 = np.loadtxt(path4, dtype=str, delimiter='  ')
        train_dataset6 = np.loadtxt(path5, dtype=str, delimiter='  ')


        path_test = "/home/xly/pFred_medical_segmentation/data_process/data_list/BIDMC_test.txt"##0.8
        path_test1 = "/home/xly/pFred_medical_segmentation/data_process/data_list/BMC_test.txt"##0.8
        path_test2 = "/home/xly/pFred_medical_segmentation/data_process/data_list/HK_test.txt"
        path_test3 = "/home/xly/pFred_medical_segmentation/data_process/data_list/I2CVB_test.txt"##0.8
        path_test4 = "/home/xly/pFred_medical_segmentation/data_process/data_list/RUNMC_test.txt"##0.8
        path_test5 = "/home/xly/pFred_medical_segmentation/data_process/data_list/UCL_test.txt"

        test_dataset1 = np.loadtxt(path_test, dtype=str, delimiter='  ')
        test_dataset2 = np.loadtxt(path_test1, dtype=str, delimiter='  ')
        test_dataset3 = np.loadtxt(path_test2, dtype=str, delimiter='  ')
        test_dataset4 = np.loadtxt(path_test3, dtype=str, delimiter='  ')
        test_dataset5 = np.loadtxt(path_test4, dtype=str, delimiter='  ')
        test_dataset6 = np.loadtxt(path_test5, dtype=str, delimiter='  ')
        
        
        
        if idx == 0:
           train_dataset = train_dataset1
           test_dataset = test_dataset1
        if idx == 1:
           train_dataset = train_dataset2
           test_dataset = test_dataset2
        if idx == 2:
           train_dataset = train_dataset3
           test_dataset = test_dataset3
        if idx == 3:
           train_dataset = train_dataset4
           test_dataset = test_dataset4
        if idx == 4:
           train_dataset = train_dataset5
           test_dataset = test_dataset5
        if idx == 5:
           train_dataset = train_dataset6
           test_dataset = test_dataset6
        if idx == 6:
           train_dataset = train_dataset7
           test_dataset = test_dataset7
        return train_dataset, test_dataset


def average_weights(w):
    """
    Returns the average of the weights.
    """
    w_avg = copy.deepcopy(w[0])
    for key in w_avg.keys():
        for i in range(1, len(w)):
            w_avg[key] += w[i][key]
        w_avg[key] = torch.div(w_avg[key], len(w))
    return w_avg


def exp_details(args):
    print('\nExperimental details:')
    print(f'    Model     : {args.model}')
    print(f'    Optimizer : {args.optimizer}')
    print(f'    Learning  : {args.lr}')
    print(f'    Global Rounds   : {args.epochs}\n')

    print('    Federated parameters:')
    if args.iid:
        print('    IID')
    else:
        print('    Non-IID')
    print(f'    Fraction of users  : {args.frac}')
    print(f'    Local Batch size   : {args.local_bs}')
    print(f'    Local Epochs       : {args.local_ep}\n')
    return
